<?php



class ApiAction extends Action {
			


 
	public  function login(  ){
		$data = I('post.data');
		//$data = json_decode(htmlspecialchars_decode(I('post.data')),true);
		if(!$data){
			$this->api_fail(C('FAIL'),'没有用户信息');
		}
		$cond = array(
			'LicensePlate|GpsDeviceNumber|DeviceNumber'=>$data['username'],
			'Password'=>$data['password']
		);
		$userinfo = M('jms_vehicle')->where($cond)->find();
		if(!$userinfo){
			$this->api_fail(C('FAIL'),'用户名或者密码不正确');
		}
		$token = md5($data['username'].I('post.loginMark').$data['password'].date('Y-m-d H:i:s'));
		$result = \Jiaruan\RedisCache::setSessionRules(I('post.loginMark'),$token);
		if($result === false){
		    $this->api_fail(C('FAIL'),'添加redis失败');
		  }
		$where = array("ID" => $userinfo['ID']);
		$data = array(
			"LoginMark" => I('post.loginMark'),
			"Token" => $token
		);
		$res = M('jms_vehicle')->createSave($where,$data);
		if(!$res){
			$this->api_fail(C('FAIL'),'token信息保存失败');
		}
		$baseinfo = array(
			"userId" => $userinfo['ID'],
			"enCode" => "System",
			"account" => $userinfo['FullName'],
			"password" => $userinfo['Password'],
			"secretkey" => '',
			"realName" => $userinfo['FullName'],
			"nickName" => $userinfo['FullName'],
			"headIcon" => ".jpg",
			"gender" => $userinfo['Sex'],
			"mobile" => $userinfo['UserPhone'],
			"telephone" => $userinfo['Telephone'],
			"email" => $userinfo['Email'],
			"oICQ" => $userinfo['QQ'],
			"weChat" => $userinfo['WxName'],
			"companyId" => "",
			"companyIds" => array(),
			"departmentId" => "",
			"departmentIds" => array(),
			"openId" => $userinfo['WxOpenId'],
			"roleIds" => $userinfo['RoleId'],
			"postIds" => "",
			"isSystem" => true,
			"appId" => "renlian_1.0.0_App",
			"logTime" => date('Y-m-d H:i:s'),
			"iPAddress" => $_SERVER['REMOTE_ADDR'],
			"browser" => "Safari 11.0",
			"loginMark" => I('post.loginMark'),
			"token" => $token,
			"imUrl" => '',
			"imOpen" => '',
			"wfProcessId" => '',
			"photoUrl" => $userinfo['Avatar'],
			"plate" => $userinfo['LicensePlate'],
			'deviceNumber' => $userinfo['DeviceNumber'],
			'gpsNumber' => $userinfo['GpsDeviceNumber'],
			'cityid' => $userinfo['CityId']
		);
		$data = array(
			"baseinfo" => $baseinfo,
			"post" => array(),
			"role" => array()
		);
		$this->api_success('登录成功',$data);
	}
	
 
	public  function modifypassword(  ){
		$this->token_verify();
		$post_data = I('post.data');
		if( empty($post_data) ){
			$this->api_fail(C('FAIL'),'post_data不能为空!');
		}
		$userid = $post_data['userid'];
		$newpassword = $post_data['newpassword'];
		$oldpassword = $post_data['oldpassword'];
		if(!M('jms_vehicle')->where(array('ID'=>$userid,'Password'=>$oldpassword))->find()){
			$this->api_fail(C('FAIL'),'旧密码不正确');
		}
		$where = array(
			'ID' => $userid,
			'Password' => $oldpassword
		);
		$data = array(
			'Password' => $newpassword
		);
		$res = M('jms_vehicle')->createSave($where,$data);
		if(!$res){
			$this->api_fail(C('FAIL'),'修改密码失败');
		}
		$this->api_success('修改成功');
		
	}
	
 
	public  function get_baojing_info(  ){
		$this->token_verify();
		$plate = I('get.plate');
		$msg = M('jms_baojing_message')->where(array('Type'=>C('STOLEN_ALARM'),'LicensePlate'=>$plate))->select();
		if(!$msg){
			$this->api_fail(C('FAIL'),'报警信息不存在');
		}
		$this->api_success('成功',$msg);
	}
	
 
	public  function get_map_index_data(  ){
		$this->token_verify();
		$deviceNumber = $_GET['data']['deviceNumber'];
		$licensePlate = $_GET['data']['licensePlate'];
		
		if(!$deviceNumber){
			$this->api_fail(C('FAIL'),'faild, no deviceNumber !');
		}
		
		//获取车辆最新位置mysql
		/*
		$result = M('jms_vehicle')->field('GpsLongitude, GpsLatitude, Address, FenceShapeInfo, LockStatus, FenceAlarmEnable, Battery, GpsOnlineTime, Speed, CityId')->where(array('DeviceNumber' => $deviceNumber))->find();
		*/
		
		//redis获取
		$vehicle = Redis('fdrc_vehicle','hash');
		//var_dump($vehicle);
		$vehicleInfo = $vehicle->get($deviceNumber);
		$vehicleInfo = json_decode($vehicleInfo, true);
		
		
		$rlfd_vehicle_fence = Redis('rlfd_vehicle_fence','hash');
		$fence = $rlfd_vehicle_fence->get($licensePlate);
		//$fence = json_decode($fence, true);
		
		$lastLocReis = Redis('rfld_gps_last_location','hash');
		$lastLoction = $lastLocReis->get(strtoupper($gpsNumber));
		$lastLoction = $lastLoction = json_decode($lastLocation, true);
		
		/*
		if(!$result){
			$this->api_fail(C('FAIL'),'cant find this vehicle !');
		}
		*/
		$onlineTimeStamp = strtotime($lastLoction['GpsOnlineTime']);
		if(!$onlineTimeStamp){
			$onlineTimeStamp = 0;
		}
		
		/*
		if(!$result['GpsLongitude'] || !$result['GpsLatitude']){
		
			$where = array('ID' => $result['CityId']);
			$cityLngLat = M('jms_city')->field('CenterLng, CenterLat')->where($where)->find();
			$result['GpsLongitude'] = $cityLngLat['CenterLng'];
			$result['GpsLatitude'] = $cityLngLat['CenterLat'];
		}
		*/
		$mapData = array(
			'vehicleLocation' => array('longitude' => $lastLoction['GpsLongitude'], 'latitude' => $lastLoction['GpsLatitude']),
		//	'vehicleAddress' => $result['Address'],
			'lockStatus' => $vehicleInfo['LockStatus'],
			'fenceShapeInfo' => $fence,
			'battery' => $lastLoction['Battery'],
		//	'fenceAlarmStatus' => $result['FenceAlarmEnable'],
			'onlineTime' => $onlineTimeStamp,
			'speed' => $result['Speed']
		);
		
		$this->api_success('success', $mapData);
		
	}
	
 
	public  function get_insure_info(  ){
		$this->token_verify();
		$cityid = I('get.cityid');
		$insure_info = M('jms_insurance')->where(array('CityId'=>$cityid))->select();
		if(!$insure_info){
			$this->api_fail(C('FAIL'),'保险信息不存在');
		}
		$this->api_success('成功',$insure_info);
	}
	
 
	public  function get_user_platenumber(  ){
		$this->token_verify();
		$userid = I('get.userid');
		if(!$userid){
			$this->api_fail(C('FAIL'),'用户id不存在');
		}
		$plate_info = M('jms_vehicle')->where(array('ID'=>$userid))->field('ID,LicensePlate')->select();
		if(!$plate_info){
			$this->api_fail(C('FAIL'),'该车主没有使用的车牌');
		}
		$this->api_success('成功',$plate_info);
	}
	
 
	public  function submit_add_baojing(  ){
		$this->token_verify();
		$post_data = I('post.data');
		if( empty($post_data) ){
			$this->api_fail(C('FAIL'),'post_data不能为空!');
		}
		$Keyword = strtoupper($post_data['LicensePlate']);
		if ( empty($Keyword)) {
			$this->api_fail(C('FAIL'),'报警车辆不能为空');
		}
		$userid = $post_data['userid'];
		if ( empty($userid)) {
			$this->api_fail(C('FAIL'),'用户id不能为空');
		}
		$stolenaddress = $post_data['StolenAddress'];
		if ( empty($stolenaddress)) {
			$this->api_fail(C('FAIL'),'事发地址不能为空');
		}
		//获取登录用户城市id
		/*$cond = array('ID'=>$userid);
		$cityid = M('uc_user')->where($cond)->getField('CityId');
		if(!$cityid){
			$this->api_fail('failerror','获取登录城市失败！');
		}*/
		$vehicle_info = M('jms_vehicle')->where(array( 'LicensePlate|IdCard|UserPhone' => $Keyword ))->field('ID,UserId,CityId,IdCard,UserPhone,LicensePlate')->find();
		if(!$vehicle_info){
			$this->api_fail(C('FAIL'),'报警车辆不存在！');
		}
		/*if( $vehicle_info['CityId'] != $cityid ){
			$this->api_fail('failerror','该车辆不在管辖区域，无法添加报警！');
		}
		if(!$vehicle_info['UserId']){
			$this->api_fail('failerror','此车辆还未开户，不能添加报警信息！');
		}*/
		
		//$vehicle_id = $vehicle_info['ID'];
		/*$chezhu_id = $vehicle_info['UserId'];
			//$chezhu_info = fd_get_userinfo($chezhu_id);
			//$chezhu_info = get_chezhu_info($chezhu_id);*/
		//$this->api_check_vehicle_isrepeat2($vehicle_id);
		if (I('post.StolenDate')) {
			$StolenDate = $post_data['StolenDate'];
			$StolenDate = date('Y-m-d',strtotime($StolenDate));
			// 被盗日期不能超过当前时间
			$now_time = date('Y-m-d');
			if(strtotime($StolenDate) > strtotime($now_time)){
				$this->api_fail(C('FAIL'),'被盗日期不能超过当前时间！');
			}
		} else {
			$StolenDate = date('Y-m-d');
		}
		if(M('jms_baojing')->where(array('LicensePlate' => $vehicle_info['LicensePlate'],'StolenState'=>0))->find()){
			$this->api_fail(C('FAIL'),'报警信息已经存在');
		}
		$data = array(
			'WoContent' => $post_data['WoContent'], 
			'VehicleId' =>  $userid, 
			'LicensePlate' => $vehicle_info['LicensePlate'], 
			'IdCard' => $vehicle_info['IdCard'], 
			'UserId' => $userid, 
			'UserPhone' => I('post.UserPhone'),
			'CityId' => $vehicle_info['CityId'], 
			'SubmitUserId' => $userid, 
			'SubmitTime' => date('Y-m-d H:i:s'), 
			'StolenDate' => $StolenDate,
			'StolenCityId' => $vehicle_info['CityId'], //新增：被盗城市id
		);
		if (!M('jms_baojing')->createAdd($data)) {
			$this->api_fail(C('FAIL'),'添加报警信息失败');
		}
		$this->api_success('添加报警信息成功');
		
	}
	
 
	public  function update_jg_registrationid(  ){
		$this->token_verify();
		$post_data = I('post.data');
		//$post_data = json_decode(htmlspecialchars_decode(I('post.data')),true);
		
		if( empty($post_data) ){
			$this->api_fail(C('FAIL'),'post_data不能为空!');
		}
		$regid = $post_data['regid'];//极光推设备唯一标识id
		if( empty($regid) ){
			$this->api_fail(C('FAIL'),'极光推注册id不能为空!');
		}
		if(!$post_data['uid']){
			$this->api_fail(C('FAIL'),'uid不能为空!');
		}
		$cond = array(
			'ID' => $post_data['uid']
		);
		$result = M('jms_vehicle')->where($cond)->setField('JgClientRegistrationId',$regid);
		if( false === $result ){
			$this->api_fail(C('FAIL'),'更新极光推注册信息失败! error:'.M('jms_vehicle')->getDbError());
		}
		$this->api_success('更新成功');
	}
	
 
	public  function save_fence_info(  ){
		$this->token_verify();
		$fence_info =I('post.data');
		$fenceData = htmlspecialchars_decode($fence_info['data']);
		$plate = $fence_info['plate'];
		
		if( !$fence_info || !$plate){
			json_fail('Missing param !');
		}
		var_dump($fence_info );
		var_dump($fenceData );exit;
		$data = array(
			'fenceStatus' => $fence_info['fenceAlarmEnable'] == 'true' ? true : false,
			'fenceInfo' => $fenceData
		);
		//围栏信息改为存入redis表 rlfd_vehicle_fence（ key车牌号，value围栏信息）
		$rlfd_vehicle_fence = Redis('rlfd_vehicle_fence','hash');
		$key = $plate;
		$val = json_encode($data, JSON_UNESCAPED_UNICODE);
		$hash = array($key=>$val);
		$result = $rlfd_vehicle_fence->add($hash);
		if( $result === false ){
			json_fail('保存失败');
		}
		json_success('保存成功');
	}
	
 
	public  function get_gps_route(  ){
		$this->token_verify();
		$postParm = I('post.data');
		$search_date = $postParm['date'];
		$gps_number = $postParm['gpsNumber'];
		if( !$gps_number || !$search_date){
			json_fail('Missing param !');
		}
		
		
		$timestamp = strtotime($search_date);
		if( !$timestamp ){
			json_fail('Date format error !');
		}
		$start_date = strtotime( date('Y-m-d 00:00:00',$timestamp) );
		$end_date = strtotime( date('Y-m-d 23:59:59',$timestamp) );
		$cond = array(
				'DeviceId' => $gps_number,
				'DeviceTime' => array( 'between', array($start_date,$end_date) ),
		);
		$fields = 'Longitude as lng,Latitude as lat,Speed as speed, DeviceTime as deviceTime';
		$dateStr = str_replace("-","",$search_date);
		$route_list = M('gps_location_'.$dateStr, '', C('DB_DSN_GPS'))->field($fields)->where($cond)->order('DeviceTime asc')->select();
		//var_dump(M('gps_location_'.$dateStr, '', C('DB_DSN_GPS'))->getLastSql());
		if( !$route_list ){
			json_fail('无轨迹 !');
		}
		
		foreach($route_list as &$v){
			$v['deviceTime'] = date('Y-m-d H:i:s', $v['deviceTime']);
		}
		
		$route_data = json_encode($route_list);
		//$testData = json_encode($testData);
		json_success('success',$route_data);
		//json_success('success',$testData);
		
	}
	
 
	public  function change_lock_status(  ){
		$this->token_verify();
		$lock_state = I('post.data')['lockStatus'];
		$device_number = I('post.data')['deviceNumber'];
		if( !$device_number || $lock_state === ''){
			json_fail('Missing param !');
		}
		//检查锁定状态值
		if( !is_numeric($lock_state) && ($lock_state != 0 && $lock_state != 1) ){
			json_fail('unknown state !');
		}
		$cond = array('DeviceNumber' => $device_number);
		$result = M('jms_vehicle')->where($cond)->setField('LockStatus',$lock_state);
		if( $result === false ){
			json_fail('设置失败');
		}
		json_success('设置成功');
	}
	
 
	public  function api_success( $msg, $data ){
		$array = array(
			'success'=>true,
			'message'=>$msg,
			'data' => $data,
			'code'=>200
		);
		echo json_encode($array,JSON_UNESCAPED_UNICODE);
		exit;
	}
	
 
	public  function api_fail( $code, $msg, $data ){
		$array = array(
				'success'=>false,
				'message'=>$msg,
				'data' => $data,
				'code'=>$code
		);
		echo json_encode($array,JSON_UNESCAPED_UNICODE);
		exit;
	}
	
 
	public  function get_gonggao_info(  ){
		$this->token_verify();
		$plate = I('get.plate');
		$msg = M('jms_baojing_message')->where(array('Type'=>C('BROADCASTING'),'LicensePlate'=>$plate))->select();
		if(!$msg){
			$this->api_fail(C('FAIL'),'公告信息不存在');
		}
		$this->api_success('成功',$msg);
	}
	
 
	public  function token_verify(  ){
		$token = I('token');//用户登录token
		$login_mark = I('loginMark');
		if(!$token){
			$this->api_fail(C('FAIL'),'token不存在 !');
		}
		if(!$login_mark){
			$this->api_fail(C('FAIL'),'login_mark不存在 !');
		}
		//获取token
		$redis = Redis('czapp_client_login_session','hash');
		$key = $login_mark;
		$val = json_decode($redis->get($key),true);
		
		if(!$val){
			$this->api_fail(C('FAIL'),'无效token1 !');
		}
		
		//验证token是否一致 
		if( $token != $val['token'] ){
			$this->api_fail(C('FAIL'),'无效token2 !');
		}
		
		//验证token是否过期
		if(!$val['login_time']){
			$this->api_fail(C('FAIL'),'没有登录时间，token校验失败 !');
		}
		$login_time = strtotime($val['login_time']);
		$end_time = $login_time + $val['expire']*60;
		if(time()>$end_time){
			$this->api_fail(C('TOKEN_OVERTIME'),'token失效，请重新登录 !');
		}
	}
	
 
	public  function get_gonggao_detail(  ){
		header('Access-Control-Allow-Origin:*');
		$this->token_verify();
		$plate = I('get.plate');
		$msg = M('jms_baojing_message')->where(array('Type'=>C('BROADCASTING'),'LicensePlate'=>$plate))->find();
		if(!$msg){
			$this->api_fail(C('FAIL'),'公告信息不存在');
		}
		$this->api_success('成功',$msg);
	}
	
 
	public  function get_baojing_detail(  ){
		$this->token_verify();
		$plate = I('get.plate');
		$addtime = I('get.addtime');
		$msg = M('jms_baojing_message')->where(array('Type'=>C('STOLEN_ALARM'),'LicensePlate'=>$plate,'AddTime'=>$addtime))->find();
		if(!$msg){
			$this->api_fail(C('FAIL'),'报警信息不存在');
		}
		$this->api_success('成功',$msg);
	}
	
 
	public  function register(  ){
		$where = array('LicensePlate'=>I('post.LicensePlate'));
		$userinfo = M('jms_vehicle')->where($where)->find();
		if(!$userinfo){
			$this->api_fail(C('FAIL'),'用户车牌还未登记');
		}
		if($userinfo['FullName'] != I('post.FullName')){
			$this->api_fail(C('FAIL'),'姓名和备案时填写不一致');
		}
		if($userinfo['IdCard'] != I('post.IdCard')){
			$this->api_fail(C('FAIL'),'身份证和备案时填写不一致');
		}
		$data = array(
			'Password' => I('post.Password'),
		);
		$result = M('jms_vehicle')->createSave($where,$data);
		if(!$result){
			$this->api_fail(C('FAIL'),'注册失败');
		}
		$this->api_success('注册成功');
	}
	
 
	public  function get_fence_info(  ){
		$this->token_verify();
		$plate = I('get.data');
		if( !$plate){
			json_fail('Missing param !');
		}
		
		$rlfd_vehicle_fence = Redis('rlfd_vehicle_fence','hash');
		$fence = $rlfd_vehicle_fence->get($plate);
		if( !$fence ){
			json_fail('无围栏 !');
		}
		
		//$fence = json_encode($fence);
		json_success('success',$fence);
		
	}
	
 
	public  function get_gps_route_table(  ){
		$this->token_verify();
		$postParm = I('post.data');
		$search_date = $postParm['date'];
		$gps_number = $postParm['gpsNumber'];
		if( !$gps_number || !$search_date){
			json_fail('请检查GPS标签或者日期 !');
		}
		//$list = $this->getBTGpsRoute($search_date,'1');//test
		$list = $this->getBTGpsRoute($search_date, $gps_number); 
		$lngLatAlter = new \Jms\Algo\Geometry();
		$respData = array();
		foreach($list as $v){
			$alterRes = $lngLatAlter->convertBd09ToGcj02($v['Latitude'], $v['Longitude']);
			$nv = array(
				'lat' => $alterRes['lat'],
				'lng' => $alterRes['lng'],
				'speed' => $v['Speed'],
				'deviceTime' => $v['OnlineTime']
			);
			array_push($respData, $nv);
		}
		/*
		foreach(&$respData as &$v){
			$v['deviceTime'] = date('Y-m-d H:i:s', $v['deviceTime']);
		}
		*/
		if(!$respData){
			json_success('无轨迹');
		}
		$route_data = json_encode($respData);
		//$testData = json_encode($testData);
		json_success('success',$route_data);
		//json_success('success',$testData);
	}
	
 
	private  function getBTGpsRoute( $date, $gpsNumber ){
		if(!$gpsNumber){
			return false;
		}
		if(!$date){ 
			$date = date('Y-m-d');
		}
		//获取所有轨迹信号
		$option = array();
		$option['pagesize'] = 1000;
		$option['asc'];
		$option['fields'] = array('Longitude','Latitude','Speed','DeviceTime');
		$routesig = new \Rlfd\Route\RouteSignal();
		$list = $routesig->queryEbicyleDailyGpsSignals($gpsNumber, $date,$option);
		
		//var_dump($list);
		//var_dump(array('route'=>$list,'vehicle'=>$vehicle_info));
		return $list;
	}
	
 
	public  function get_driving_data(  ){
		$gpsNumber = $_GET['data']['gpsNumber'];
		//var_dump($_GET);
		$days = C('DRIVING_STATISTICS_DAYS');
		if(!$gpsNumber){
			json_fail('未获取到gps设备号');
		}
		if(!$days){
			$days = 5;
		}
		$drivingData = array();
		
		
		
		for($i = $days-1; $i > 0; --$i){
			$preStr2time = strtotime('-'.$i.'days');
			$date = date('Y-m-d', $preStr2time);
		/*	
			$where = array(
				'GpsDeviceNumber' => $gpsNumber,
				'Date' => $date
			);
			$sqlData = M('gps_driving_data')->where($where)->find();//当天前的数据查询sql数据库
			if($sqlData){
				$dayData = array(
					'date' => $date,
					'averageSpeed' => $sqlData['AverageSpeed'],
					'totalTime' => $sqlData['TotalTime'],
					'totalDist' => $sqlData['TotalDistance']
				);
				array_push($drivingData, $dayData);
				continue;
			}
		*/
			$cache = S($gpsNumber.'_cache'.$date);
			if($cache){
				array_push($drivingData, $cache);
				continue;
			}else{
				$dayData = $this->searchDrivingData($gpsNumber, $date);
				array_push($drivingData, $dayData);
				S($gpsNumber.'_cache'.$date, $dayData, 3600*24*7);
			}
			
		}
		//当日
		$todayDate = date('Y-m-d');
		
		$todayCache = S($gpsNumber.'_cache'.$todayDate);
		if(!$todayCache){
			$todayData = $this->searchDrivingData($gpsNumber, $todayDate);
			array_push($drivingData, $todayData);
			$todayCache = S($gpsNumber.'_cache'.$todayData, $todayData, 3600*24);
		}else{
			$newOnlineTime = M('jms_vehicle')->where(array('GpsDeviceNumber' => $gpsNumber))->getField('GpsOnlineTime');
			$nTime = strtotime($newOnlineTime);
			$oTime = strtotime($lastOnlineTime);
			if($nTime == $oTime){
				array_push($drivingData, $todayCache);
			}else{
				$todayData = $this->searchDrivingData($gpsNumber, $date);
				array_push($drivingData, $todayData);
				$todayCache = S($gpsNumber.'_cache'.$todayDate, $todayData, 3600*24);
			}
		}
		
		//dump($drivingData);
		if(!$drivingData){
			json_fail('未查询到近'.$days.'日行驶数据');
		}
		
		json_success('查询成功', $drivingData);
		
		
		
	}
	
 
	private  function searchDrivingData( $gpsNumber, $date ){
		if(!$gpsNumber){
			return false;
		}
		
		$start = microtime(true);
		
		$result = $this->getBTGpsRoute( $date,$gpsNumber);
		
		$end = microtime(true);
		
		$totalTime = 0;
		$totalDist = 0;
		
		$lastOnlineTime =end($result)['OnlineTime'];
		
		for($i = 0; $i < count($result)-1; ++$i){
			$lat1 = $result[$i]['lat'];
			$lng1 = $result[$i]['lng'];
			$lat2 = $result[$i+1]['lat'];
			$lng2 = $result[$i+1]['lng'];
			$dist = $this->get_2points_distance($lat1,$lng1,$lat2,$lng2 );
			$totalDist += $dist;
			$time = strtotime($result[$i+1]['OnlineTime']) - strtotime($result[$i]['OnlineTime']);
			$totalTime += ($time/3600);
		}
		
		return array(
			'totalTime' => $totalTime,
			'totalDist' => $totalDist,
		//	'averageSpeed' => $totalDist/$totalTime,
			'lastOnlineTime' => $lastOnlineTime,
			'caculateTime' => $end - $start
		);
		
		
	}
	
 
	private  function get_2points_distance( $lat1, $lng1, $lat2, $lng2, $radius = 6378.137 ){
		$rad = floatval(M_PI / 180.0);
		$lat1 = floatval($lat1) * $rad;
		$lng1 = floatval($lng1) * $rad;
		$lat2 = floatval($lat2) * $rad;
		$lng2 = floatval($lng2) * $rad;
		
		$theta = $lng2 - $lng1;
		
		$dist = acos(sin($lat1) * sin($lat2) +
					 cos($lat1) * cos($lat2) * cos($theta)
					);
		
		
		if ($dist < 0 ) {
			$dist += M_PI;
		}
		
		return $dist = $dist * $radius;
	}
	
 
	public  function test_function(  ){
		$lat1 = '31.253411';
		$lng1 = '121.518998';
		
		$lat2 = '31.277117';
		$lng2 = '120.744587';
		
		$distance = $this->get_2points_distance($lat1, $lng1, $lat2, $lng2);
		var_dump($distance);
	}
	
 
	public  function get_vehicle_ElectronicPlateUrl(  ){
		$this->token_verify();
		$userid = I('userid');
		$result = M('jms_vehicle')->where(array('ID'=>$userid))->field('FrontElectronicPlateUrl,BackElectronicPlateUrl')->cache('key',86400)->select();
		$electronicPlateUrl = S('key');
		$this->api_success('成功',$electronicPlateUrl[0]);
	}
	
 
	public  function getCityInfo(  ){
		$this->token_verify();
		$cityid = I('get.cityid');
		if(!$cityid){
			$this->api_fail(C('FAIL'),'开户城市不存在');
		}
		$parentcity = M('jms_city')->where(array('ID'=>$cityid))->find();
		
		$child_1 = M('jms_city')->where(array('ParentId'=>$parentcity['ParentId']))->select();
		$this->api_success('成功',$child_1);
		
	}
	
 
	public  function get_cityinfo_by_cityid(  ){
		$cityid = I('cityid');
		$ids = M('jms_city')->field('ParentId,ProvinceId')->where(array('ID'=>$cityid))->find();
		$result = $ids['ProvinceId'].','.($ids['ParentId']-100).','.($cityid-1000);
		$this->api_success('成功',$result);
		
	}
	

}